﻿#include "StdAfx.h"
#include "AboutDlg.h"

/*
	AboutDlg 를 따로 뺀 이유 : 
	http://support.microsoft.com/kb/317799/ko

*/
#define DEF_ABOUT_BG_COLOR				Color(255, 230, 234, 240)
#define DEF_ABOUT_TEXT_COLOR			Color(255, 34, 34, 34)
#define DEF_ABOUT_COPYRIGHT_COLOR		Color(255, 136, 136, 136)

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	m_strCopyRight = _T("Copyrightⓒ NHN Technology Services Corp.");
    m_pImageLogo = NULL;
    m_pImageBG = NULL;
}

CAboutDlg::~CAboutDlg()
{
	if(m_pImageLogo)
	{
		delete m_pImageLogo;
		m_pImageLogo = NULL;
	}

	if(m_pImageBG)
	{
		delete m_pImageBG;
		m_pImageBG = NULL;
	}
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CLOSE()
END_MESSAGE_MAP()




BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	LoadVersionInfo();

	CString strLogoImgPath = _T(""), strImgDir = _T(""), strLogoFileName, strBGFileName, strBGImgPath = _T("");

	strImgDir = GetAppImgDir();	
	strLogoFileName = _T("img_logo_big2.png");	
	strLogoImgPath.Format(_T("%s\\%s"), strImgDir, strLogoFileName);

	strBGFileName = _T("Login_BG.png");
	strBGImgPath.Format(_T("%s\\%s"), strImgDir, strBGFileName);

	m_pImageLogo = new Image(strLogoImgPath);
	m_pImageBG = new Image(strBGImgPath);

	SetSkin();

	GetDlgItem(IDC_STATIC_VERSION)->SetWindowText(m_strUpdateVersion);
	GetDlgItem(IDC_STATIC_DATE)->SetWindowText(m_strUpdateDate);

	SetWindowPos(0, 0, 0, 380, 220, SWP_NOMOVE );
	SetWindowText(_T(""));
	g_hMessageBox[MAX_MESSAGEBOX_COUNT-1] = m_hWnd;
	return TRUE;  // return TRUE unless you set the focus to a control
	// 예외: OCX 속성 페이지는 FALSE를 반환해야 합니다.
}

void CAboutDlg::SetSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));		

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) {
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else {
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\Style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("AboutDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}//lint !e438

void CAboutDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt, rtLogo, rtDlg, rtVersion, rtDate, rtCopyRight;
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	rtLogo.SetRect(130, 30, 255, 57);
	rtDlg.SetRect(0, 0, rt.Width(), rt.Height());
	rtVersion.SetRect(0, 80, rt.Width(), 15 + 80);
	rtDate.SetRect(0, 100, rt.Width(), 15 + 100);
	rtCopyRight.SetRect(0, 130, rt.Width(), 12 + 130);

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeNone);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		if(m_pImageBG)
			DrawImageToStretchHorz(&graph, m_pImageBG, &rtDlg, &rtDlg, DEF_ABOUT_BG_COLOR, &ImgAttr);

		if(m_pImageLogo)
			DrawImageToDest(&graph, m_pImageLogo, &rtPS, &rtLogo, &ImgAttr);

		
		DrawTextToDest2(&graph,	m_strUpdateVersion, &rtPS, &rtVersion, g_defaultFontFaceName, 10, StringAlignmentCenter, FontStyleBold, DEF_ABOUT_TEXT_COLOR);
		DrawTextToDest2(&graph,	m_strUpdateDate, &rtPS, &rtDate, g_defaultFontFaceName, 10, StringAlignmentCenter, FontStyleBold, DEF_ABOUT_TEXT_COLOR);
		DrawTextToDest2(&graph,	m_strCopyRight, &rtPS, &rtCopyRight, g_defaultFontFaceName, 8, StringAlignmentCenter, FontStyleBold, DEF_ABOUT_COPYRIGHT_COLOR);		
			
		BitBlt(dc.GetSafeHdc(), 0, 0, rt.Width(), rt.Height(), hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}


BOOL CAboutDlg::OnEraseBkgnd(CDC* pDC)
{	 
	return TRUE;
}


void CAboutDlg::LoadVersionInfo()
{
	CString strVersion = _T("");
	CString strLastUpdate = _T("");
	CString strFormat;
	HRSRC hRsrc = FindResource(NULL, MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	if (hRsrc != NULL)
	{
		HGLOBAL hGlobalMemory = LoadResource(NULL, hRsrc);
		if (hGlobalMemory != NULL)
		{
			CString rVersion;
			CString rSpecialBuild;
			LPVOID pVersionResouece = LockResource(hGlobalMemory);
			LPVOID pVersion = NULL;
			LPVOID pLastUpdate = NULL;
			DWORD uLength,langD;
			BOOL retVal;
			retVal = VerQueryValue(pVersionResouece, _T("\\VarFileInfo\\Translation"), (LPVOID*)&pVersion, (UINT*)&uLength);
			if (retVal && uLength == 4) 
			{
				memcpy(&langD,pVersion,4); 
				rVersion.Format(_T("\\StringFileInfo\\%02X%02X%02X%02X\\ProductVersion"),
								(langD & 0xff00)>>8,langD & 0xff,(langD & 0xff000000)>>24, 
								(langD & 0xff0000)>>16);
				rSpecialBuild.Format(_T("\\StringFileInfo\\%02X%02X%02X%02X\\SpecialBuild"),
										(langD & 0xff00)>>8,langD & 0xff,(langD & 0xff000000)>>24, 
										(langD & 0xff0000)>>16);
			}
			else
			{
				rVersion.Format(_T("\\StringFileInfo\\%04X04B0\\ProductVersion"), GetUserDefaultLangID());
				rSpecialBuild.Format(_T("\\StringFileInfo\\%04X04B0\\SpecialBuild"), GetUserDefaultLangID());
			}

			if( VerQueryValue(pVersionResouece, (LPCTSTR)rVersion, (LPVOID*)&pVersion, (UINT *)&uLength) != 0 )
			{
				strVersion.Format(_T("%s"), pVersion);
			}

			if( VerQueryValue(pVersionResouece, (LPCTSTR)rSpecialBuild, (LPVOID*)&pLastUpdate, (UINT *)&uLength) != 0 )
			{
				strLastUpdate.Format(_T("%s"), pLastUpdate);
			}
		}
		FreeResource(hGlobalMemory);
	}

	strFormat.LoadString(IDS_ABOUT_VERSION);
	m_strUpdateVersion.Format(strFormat, strVersion);
	
	strFormat.LoadString(IDS_ABOUT_DATE);
	m_strUpdateDate.Format(strFormat, strLastUpdate);
	

}
void CAboutDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	g_hMessageBox[MAX_MESSAGEBOX_COUNT-1] = NULL;
	EndDialog(0);
	//CDialog::OnClose();
}
